# $Id: config.rb,v 1.2 2001/09/03 22:54:46 not Exp $

# Configuration file class

require 'delegate'

class Config < SimpleDelegator

  attr_reader :config

  def initialize
    @config = {}
    @config_array = {}
    @array_key = []
    super(@config)
  end

  private
  def reload(key)
    if @array_key.include?(key) then
      @config[key] = @config_array[key]
    else
      @config[key] = @config_array[key][-1]
    end
  end

  def set(key, val)
    @config_array[key] = [] unless @config_array.key?(key)
    @config_array[key] << val
    reload(key)
  end

  public
  def []=(key, val)
    set(key, val)
  end

  public
  def load(filename)
    file = open(filename)
    begin
      file.each{ |line|
        if /^(\w+)\s*=\s*(.+)$/ =~ line then
          begin
            set($1.strip, eval($2.strip.tosjis))
          rescue             # ςȂ͕̂ƂĈ
            set($1.strip, $2.strip.tosjis)
          rescue ScriptError # ςȂ͕̂ƂĈ (ruby 1.5.x ?)
            set($1.strip, $2.strip.tosjis)
          end
        end
      }
    rescue Errno::ENOENT
      $stderr.print "\n** Can't open Configuration file: '#{filename}'\n"
      exit
    ensure
      file.close
    end
  end

  def setarray(*keys)
    keys.each{ |key|
      @array_key << key
      reload(key)
    }
  end

  def unsetarray(*keys)
    keys.each{ |key|
      @array_key.delete(key)
      reload(key)
    }
  end

  def Config::load(filename)
    config = Config::new
    config.load(filename)
    config
  end
  
end

if __FILE__ == $0

  Test =Config::new
  Test.load('ndiary.conf')
  p Test['FILTER']
  Test.setarray('FILTER')
  p Test['FILTER']
end
