# $Id: imagesize.rb,v 1.5 2003/12/10 16:42:29 not Exp $

begin
  require 'image_size'
  Image_Size = ImageSize.dup
rescue LoadError
  #
end

begin
  require 'open-uri'
rescue LoadError
  #
end

class ImageSize

  def initialize(filename)
    @filename = filename
  end

  def gif
    f = open(@filename)
    f.binmode
    f.read(6)
    w1, w2, h1, h2 = f.read(4).unpack("CCCC")
    width  = w1 + (w2 << 8)
    height = h1 + (h2 << 8)
    f.close
    return width, height
  end

  def png
    f = open(@filename)
    f.binmode
    f.read(16)
    w3, w2, w1, w0, h3, h2, h1, h0 = f.read(8).unpack("CCCCCCCC")
    width  = w0 + (w1 << 8) + (w2 << 16) + (w3 << 24)
    height = h0 + (h1 << 8) + (h2 << 16) + (h3 << 24)
    f.close
    return width, height
  end

  def jpg
    width = height = comment_length = 0
    comment = ""
    f = open(@filename)
    f.binmode

    f.each("\xff"){ |data|
      if data[0] >= 0xc0 and data[0] <= 0xc3 then
        width  = (data[6] << 8) + data[7]
        height = (data[4] << 8) + data[5]
        break
      end
      if data[0] == 0xfe then
        comment_length = data[1] + data[2] - 2
        comment = data[3, comment_length]
      end
    }
    return width, height, comment
  end

  def ImageSize::size(filename)

    begin
      if defined?(Image_Size) then
        open(filename, "rb"){ |f|
          img = Image_Size::new(f.read)
          comment = ""
          if img.get_type == 'JPEG' then
            img2 = ImageSize::new(filename)
            comment = img2.jpg[2]
          end
          return img.get_width.to_i, img.get_height.to_i, comment
        }
      else
        img = ImageSize::new(filename)
        case filename[-4..-1].downcase
        when '.gif'
          img.gif
        when '.png'
          img.png
        when '.jpg'
          img.jpg
        else
          return 0, 0
        end
      end
    rescue Exception
      return 0, 0
    end
  end

end
