# $Id: string.rb,v 1.8 2003/10/07 18:49:13 not Exp $

class String
  require 'nkf'
  
  # ML EĂ^uXy[XɓWJ郁\bh
  def expandtabs(tabsize = 8)
    me = self.dup
    while me.gsub!(/(^|\n)([^\t\n]*)(\t+)/) {
      $1 + $2 + " " * (tabsize * $3.size - $2.size % tabsize)
    }
    end
    me
  end

  def kconv(code) # 1 = jis / 2 = euc / 3 = ShiftJIS / 4 = utf-8
    case code
    when 1
      self.tojis
    when 2
      self.toeuc
    when 3
      self.tosjis
    when 4
      self.toutf8
    end
  end

  def tosjis
    NKF::nkf('-sxm0', self)
  end

  def toeuc
    NKF::nkf('-em0', self)
  end

  def tojis
    NKF::nkf('-jm0', self)
  end

  def toutf8
    begin
      require 'uconv'
    rescue LoadError
      begin
        require 'iconv'
      rescue LoadError
        raise NDiaryFatalError, "Can't convert UTF-8. please install 'uconv' or 'iconv'"
      end
    end

    case NKF::guess(self)
    when NKF::JIS
      begin
        Uconv::jistou8(self)
      rescue NameError
        Iconv::iconv("UTF-8", "ISO-2022-JP", self).to_s
      end
    when NKF::EUC
      begin
        Uconv::euctou8(self)
      rescue NameError
        Iconv::iconv("UTF-8", "EUC-JP", self).to_s
      end
    when NKF::SJIS
      begin
        Uconv::sjistou8(self)
      rescue NameError
        Iconv::iconv("UTF-8", "CP932", self).to_s
      end
    else
      self
    end
  end

end

