# $Id: calendar.rb,v 1.12 2003/12/10 16:42:05 not Exp $

=begin

  calendar.rb

    nDiary Plug-in  J_[̍쐬

    etւ̃Nt̃J_[쐬܂B

    option:
      lang=en         Atp\Lɂ܂B(Sun, Mon, ...)
      lang=en2        Atp\Lɂ܂B(Su,  Mo,  ...)
      mode=enikki     GLtB^̏ɓK摜΃TlC\
                      摜̃TCY͉L̗̂悤 CSS Ŏw肵ĂB

                      table.enikkicalendar tr td, table.enikkicalendar tr td img {
                        width: 50px;
                        height: 30px;
                        border: 0;
                      }


      exsample:
        <!--plug=calendar?lang=en-->

=end


def plug(opt)
  require 'date'

  begin
    require 'date/holiday'
    holiday_flag = true
  rescue LoadError
    holiday_flag = false
  end

  if self.kind_of?(LastDiary) or self.kind_of?(Topics) then
    thismonth = @diaries[0][0..5]
  elsif self.kind_of?(PastDiary) then
    thismonth = @targetMonth
  else
    return
  end

  y = thismonth[0..3].to_i
  m = thismonth[4..5].to_i


  if m  == 12 then
    nextmonth = sprintf("%04d01", y + 1)
  else
    nextmonth = sprintf("%04d%02d", y, m + 1)
  end

  if m  == 1 then
    prevmonth = sprintf("%04d12", y - 1)
  else
    prevmonth = sprintf("%04d%02d", y, m - 1)
  end

  monthlink     = date2monthlyfilelink(thismonth)
  nextmonthlink = date2monthlyfilelink(nextmonth)
  prevmonthlink = date2monthlyfilelink(prevmonth)
  nextmonthlink = %Q!<a href="#{nextmonthlink}" title="next month">&gt;&gt;</a>! unless nextmonthlink.empty?
  prevmonthlink = %Q!<a href="#{prevmonthlink}" title="previous month">&lt;&lt;</a>! unless prevmonthlink.empty?

  nextpartlink = ''
  prevpartlink = ''
  alldiaries = @allDiaries.keys.sort
  firstdiaryindex = alldiaries.index(@diaries[0])
  lastdiaryindex  = alldiaries.index(@diaries[-1])
  firstdiaryindex, lastdiaryindex = lastdiaryindex, firstdiaryindex if self.kind_of?(LastDiary)
  if firstdiaryindex > 1 then
    prevpartlink = date2monthlyfilelink(alldiaries[firstdiaryindex-1])
    prevpartlink = %Q!<a href="#{prevpartlink}" title="previous part">&lt;</a>!
  end
  if lastdiaryindex < alldiaries.size - 1 then
    nextpartlink = date2monthlyfilelink(alldiaries[lastdiaryindex+1])
    nextpartlink = %Q!<a href="#{nextpartlink}" title="next part">&gt;</a>!
  end

  if opt['lang'] == 'en' then
    wdayname = %w(Sun Mon Tue Wed Thu Fri Sat)
    mo  = Time::local(y,m).strftime("%Y/%m")
  elsif opt['lang'] == 'en2' then
    wdayname = %w(Su Mo Tu We Th Fr Sa)
    mo  = Time::local(y,m).strftime("%Y-%m")
  else
    wdayname = %w(      y)
    mo  = Time::local(y,m).strftime2("%YN%m")
  end

  css = %w(sunday monday tuesday wedneday thursday friday saturday)

  topic = {}
  begin
    open(@logDirectory + thismonth + '.topic'){ |f|
      f.each{ |line|
        d, t = line.split(/\t/,2)
        t.gsub!(/\t/, "&#10;")
        t.gsub!(/<\/?([!\w]+)[^>]*>/i, '')
        topic[d[6..7].to_i] = "#{t.chomp}"
      }
    }
  rescue
    #
  end

  day = (1..28).to_a.concat((29..31).to_a.delete_if{ |d|
    begin
      !Date::valid_date?(y, m, d)
    rescue NameError
      !Date::exist?(y, m, d)
    end
  }).collect!{ |d|
    d.to_s
  }

  1.upto(Time::local(y,m,1).wday){
    day.unshift(" ")
  }

  5.downto(Time::local(y,m,day[-1]).wday){
    day.push(" ")
  }
  

  str = %Q!<div class="calendar"><table class="calendar">\n!

  enikkifiles = {}
  if opt['mode'] == 'enikki' then
    Dir::find(@outputDirectory + 'enikki/'){ |file|
      if /\/(\d{8})\.(jpg|png|gif)$/i =~ file then
        enikkifiles[$1] = '../' * @filename.scan(%r"[^/]+/").size + file.sub(@outputDirectory, '')
      end
    }
    str = %Q!<div class="enikkicalendar"><table class="enikkicalendar">\n!
  end

  str << <<HTML_END
	<tr>
    <th>#{prevmonthlink}</th>
    <th>#{prevpartlink}</th>
    <th colspan="3"><a href="#{monthlink}">#{mo}</a></th>
    <th>#{nextpartlink}</th>
    <th>#{nextmonthlink}</th>
	</tr>
HTML_END

  str << "\t<tr>\n"
  for i in 0..6
    str << %Q!\t\t<th class="#{css[i]}">#{wdayname[i]}</th>\n!
  end
  str << "\t</tr>\n"

  while day.size != 0
    str << "\t<tr>\n"
    for i in 0..6
      d = day.shift
      dd = sprintf("%02d", d.to_i)
      c = css[i]
      if holiday_flag and d != ' ' and Date::new(y,m,d.to_i).national_holiday? then
        c = 'holiday'
      end
      if @allDiaries.key?(thismonth + dd) then
        link = date2monthlyfilelink(thismonth + dd, true)
        if enikkifiles.key?(thismonth + dd) then
          str << %Q!\t\t<td class="#{c}"><a href="#{link}"><img src="#{enikkifiles[thismonth + dd]}" title="#{d.to_s+':&#10;'+topic[d.to_i]}" alt="#{d.to_s+':&#10;'+topic[d.to_i]}"#{' /' if isXHTML}></a></td>\n!
        else
          str << %Q!\t\t<td class="#{c}"><a href="#{link}" title="#{topic[d.to_i]}">#{d}</a></td>\n!
        end
      else
        str << %Q!\t\t<td class="#{c}">#{d}</td>\n!
      end
    end
    str << "\t</tr>\n"
  end
  str << "</table></div>\n"

  return str

end
